--- usr.bin/sockstat/sockstat.c
+++ usr.bin/sockstat/sockstat.c
@@ -78,6 +78,8 @@
 #define	sstosin6(ss)	((struct sockaddr_in6 *)(ss))
 #define	sstosun(ss)	((struct sockaddr_un *)(ss))
 #define	sstosa(ss)	((struct sockaddr *)(ss))
+#define	MYLOOP_MASKLEN 24
+#define	IN_MY_LOOP(i) (((in_addr_t)(i) & (0xFFFFFFFF << (32 - MYLOOP_MASKLEN))) == (127 << 24))
 
 static int	 opt_4;		/* Show IPv4 sockets */
 static int	 opt_6;		/* Show IPv6 sockets */
@@ -451,8 +453,7 @@
 				err(1, "malloc()");
 			switch (xladdr->address.sa.sa_family) {
 			case AF_INET:
-#define	__IN_IS_ADDR_LOOPBACK(pina) \
-	((ntohl((pina)->s_addr) >> IN_CLASSA_NSHIFT) == IN_LOOPBACKNET)
+#define	__IN_IS_ADDR_LOOPBACK(pina) (IN_MY_LOOP(ntohl((pina)->s_addr)))
 				if (!__IN_IS_ADDR_LOOPBACK(
 				    &xladdr->address.sin.sin_addr))
 					local_all_loopback = 0;
@@ -554,8 +555,7 @@
 					err(1, "malloc()");
 				switch (xladdr->address.sa.sa_family) {
 				case AF_INET:
-#define	__IN_IS_ADDR_LOOPBACK(pina) \
-	((ntohl((pina)->s_addr) >> IN_CLASSA_NSHIFT) == IN_LOOPBACKNET)
+#define	__IN_IS_ADDR_LOOPBACK(pina) (IN_MY_LOOP(ntohl((pina)->s_addr)))
 					if (!__IN_IS_ADDR_LOOPBACK(
 					    &xladdr->address.sin.sin_addr))
 						local_all_loopback = 0;
@@ -599,8 +599,7 @@
 					err(1, "malloc()");
 				switch (xraddr->address.sa.sa_family) {
 				case AF_INET:
-#define	__IN_IS_ADDR_LOOPBACK(pina) \
-	((ntohl((pina)->s_addr) >> IN_CLASSA_NSHIFT) == IN_LOOPBACKNET)
+#define	__IN_IS_ADDR_LOOPBACK(pina) (IN_MY_LOOP(ntohl((pina)->s_addr)))
 					if (!__IN_IS_ADDR_LOOPBACK(
 					    &xraddr->address.sin.sin_addr))
 						foreign_all_loopback = 0;
@@ -740,8 +739,7 @@
 			if ((xip->inp_fport == 0 && !opt_l) ||
 			    (xip->inp_fport != 0 && !opt_c))
 				continue;
-#define	__IN_IS_ADDR_LOOPBACK(pina) \
-	((ntohl((pina)->s_addr) >> IN_CLASSA_NSHIFT) == IN_LOOPBACKNET)
+#define	__IN_IS_ADDR_LOOPBACK(pina) (IN_MY_LOOP(ntohl((pina)->s_addr)))
 			if (opt_L &&
 			    (__IN_IS_ADDR_LOOPBACK(&xip->inp_faddr) ||
 			     __IN_IS_ADDR_LOOPBACK(&xip->inp_laddr)))
